#!/usr/bin/env python

from WebStack.Adapters.BaseHTTPRequestHandler import deploy
from WebStack.Resources.OpenIDLogin import OpenIDLoginResource, Authenticator
from WebStack.Resources.ResourceMap import MapResource
from WebStack.Resources.Static import StringResource
from WebStack.Generic import ContentType

app_url = "http://localhost:8081" # No trailing "/"!

print "Serving..."
deploy(
    MapResource({
        "login" :
            OpenIDLoginResource(
                app_url=app_url,
                authenticator=Authenticator(
                    credentials=(
                        # Local identifier,    username,  password
                        ((app_url + "/badger", "badger"), "abc"),
                        ((app_url + "/vole",   "vole"),   "xyz"),
                    )
                )
            ),

        # Some local OpenID pages.

        "badger" :
            StringResource("""
                <html>
                  <head>
                    <link rel="openid2.provider openid.server" href="%s/login" />
                    <link rel="openid2.local_id openid.delegate" href="%s/badger" />
                    <title>Badger's Home Page</title>
                  </head>
                  <body>
                    <p>Home page for the OpenID authenticated user, <code>badger</code>.</p>
                  </body>
                </html>
            """ % (app_url, app_url), ContentType("text/html")),
        "vole" :
            StringResource("""
                <html>
                  <head>
                    <link rel="openid2.provider openid.server" href="%s/login" />
                    <link rel="openid2.local_id openid.delegate" href="%s/vole" />
                    <title>Vole's Home Page</title>
                  </head>
                  <body>
                    <p>Home page for the OpenID authenticated user, <code>vole</code>.</p>
                  </body>
                </html>
            """ % (app_url, app_url), ContentType("text/html"))
        }),
    address=("", 8081),
    handle_errors=0
)

# vim: tabstop=4 expandtab shiftwidth=4
